/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.gsonmappingexample;

import com.google.gson.Gson;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author omozegieaziegbe
 */
public class GsonMappingExample {

    public static void main(String[] args) {
        
        Map<String, Object> employeeMap = new HashMap<>();
        employeeMap.put("name", "Alice Booker");

        Map<String, Object> departmentMap = new HashMap<>();
        departmentMap.put("name", "Sales");
        departmentMap.put("location", "Building C");

        Map<String, Object> project1Map = new HashMap<>();
        project1Map.put("name", "Project Epsilon");
        project1Map.put("description", "Write functional requirements");

        Map<String, Object> project2Map = new HashMap<>();
        project2Map.put("name", "Project Zeta");
        project2Map.put("description", "Write non-functional requirements");

        employeeMap.put("department", departmentMap);
        employeeMap.put("projects", List.of(project1Map, project2Map));

        Gson gson = new Gson();
        String jsonMap = gson.toJson(employeeMap);
        Employee employee = gson.fromJson(jsonMap, Employee.class);

        System.out.println(employee);

    }
}
