/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.maptopojowithjackson;

import com.fasterxml.jackson.databind.ObjectMapper;
import java.util.Map;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class MapToPojoWithJackson {

    private static final Map<String, Object> employeemap = Map.of(
            "department", new Department("Engineering", "Building A"),
            "name", "Omos",
            "projects", List.of(
                    new Project("Project A", "Developing new feature"),
                    new Project("Paris", "Bug fixing and maintenance")
            )
    );

    public static void main(String[] args) { 

        ObjectMapper objectMapper = new ObjectMapper();
        Employee employee = objectMapper.convertValue(employeemap, Employee.class);

        System.out.println(employee);

    }
}
